from installclass import BaseInstallClass
from installclass import FSEDIT_CLEAR_LINUX
from translate import N_
import os
import iutil
import isys

# custom installs are easy :-)
class InstallClass(BaseInstallClass):

    name = N_("Custom System")
    pixmap = "custom.png"
    
    sortPriority = 10000

    def __init__(self, expert):
	BaseInstallClass.__init__(self)

        if iutil.getArch() == 'ppc':
            self.addToSkipList("bootdisk")

        drive = None
        scsi = 0
        drives = isys.hardDriveDict().keys()
        drives.sort (isys.compareDrives)
        
        # iSeries requires root on disc 1, part 1
        if os.access('/proc/iSeries', os.R_OK):
            for d in drives:
                if d[0:2] == "vd" and not drive:
                    drive = d
                if d[0:2] == "sd":
                    scsi = 1
                    drive = None
                    break
        elif iutil.getArch() == 'ppc':
            drive = drives[0]
         
        part = -1

        if iutil.getArch() == 'ppc':
            if scsi == 0:
                self.addNewPartition('prep', (8, -1, 0), (drive,-1,0), (0,0))
                if drive and drive[0:2] == 'vd':
                    part = 1
        elif os.uname ()[4] != 'sparc64':
	    self.addNewPartition('/boot', (48, -1, 0), (None,-1,0), (0,0))
	self.addNewPartition('/', (700, -1, 1), (drive, part, 0), (0,0))
	self.setClearParts(FSEDIT_CLEAR_LINUX, 
	    warningText = N_("Automatic partitioning will erase any preexisting Linux "
			     "installations on your system."))

        # 2.4 kernel requires more swap, so base amount we try to get
        # on amount of memory
        (minswap, maxswap) = iutil.swapSuggestion()
	self.addNewPartition('swap', (minswap, maxswap, 1), (None, -1, 0), (0,0))





