from installclass import BaseInstallClass
from translate import *
from installclass import FSEDIT_CLEAR_ALL
import os
import iutil
import isys

class InstallClass(BaseInstallClass):

    name = N_("Server System")
    pixmap = "server.png"
    sortPriority = 10

    def __init__(self, expert):
	BaseInstallClass.__init__(self)
	self.setGroups(["Server"])
	self.setHostname("localhost.localdomain")
	if not expert:
	    self.addToSkipList("lilo")
	self.addToSkipList("authentication")
        if iutil.getArch() == 'ppc':
            self.addToSkipList("bootdisk")
        else:
            self.setMakeBootdisk(1)

        self.showgroups = [ "KDE", 
			    (0, "GNOME"),
                            (0, "X Window System"),
			    "News Server",
                            "NFS Server",
                            "Web Server",
                            "SMB (Samba) Server",
                            "DNS Name Server" ]

        drive = None
        scsi = 0            
        drives = isys.hardDriveDict().keys()
        drives.sort (isys.compareDrives)

        # iSeries requires root on disc 1, part 1
        if os.access('/proc/iSeries', os.R_OK):
            for d in drives:
                if d[0:2] == "vd" and not drive:
                    drive = d
                if d[0:2] == "sd":
                    scsi = 1
                    drive = None
                    break
        elif iutil.getArch() == 'ppc':
            drive = drives[0]
            
        part = -1

        if iutil.getArch() == 'ppc':
            if scsi == 0:
                self.addNewPartition('prep', (8, -1, 0), (drive,-1,0), (0,0))
                if drive and drive[0:2] == 'vd':
                    part = 1
	elif os.uname ()[4] != 'sparc64':
	    self.addNewPartition('/boot', (48, -1, 0), (None, -1, 0), (0,0))
	self.addNewPartition('/', (256, -1, 0), (drive, part, 0), (0,0))
	self.addNewPartition('/usr', (512, -1, 1), (None, -1, 0), (0,0))
	self.addNewPartition('/var', (256, -1, 0), (None, -1, 0), (0,0))
	self.addNewPartition('/home',(512, -1, 1), (None, -1, 0), (0,0))
	self.setClearParts(FSEDIT_CLEAR_ALL, 
	    warningText = N_("Automatic partitioning will erase ALL DATA on your hard "
			     "drive to make room for your Linux installation."))

#	self.addNewPartition('swap', (64, 256, 1), (None, -1, 0), (0,0))

        # 2.4 kernel requires more swap, so base amount we try to get
        # on amount of memory
        (minswap, maxswap) = iutil.swapSuggestion()
	self.addNewPartition('swap', (minswap, maxswap, 1), (None, -1, 0), (0,0))
