from installclass import BaseInstallClass
from installclass import FSEDIT_CLEAR_LINUX
from translate import N_
import os
import iutil
import isys

class InstallClass(BaseInstallClass):
    name = N_("Workstation")
    pixmap = "workstation.png"

    sortPriority = 1

    def __init__(self, expert):
	BaseInstallClass.__init__(self)
	self.setGroups(["Workstation Common"])
	self.setHostname("localhost.localdomain")
	if not expert:
	    self.addToSkipList("lilo")
	self.addToSkipList("authentication")
        if iutil.getArch() == 'ppc':
            self.addToSkipList("bootdisk")
        else:
            self.setMakeBootdisk(1)

        self.showgroups = [ "KDE",
                            (1, "GNOME"),
                            "Games" ]

        drive = None
        scsi = 0
        drives = isys.hardDriveDict().keys()
        drives.sort (isys.compareDrives)
     
        # iSeries requires root on disc 1, part 1
        if os.access('/proc/iSeries', os.R_OK):
            for d in drives:
                if d[0:2] == "vd" and not drive:
                    drive = d
                if d[0:2] == "sd":
                    scsi = 1
                    drive = None
                    break
        elif iutil.getArch() == 'ppc':
            drive = drives[0]
 
        part = -1

        if iutil.getArch() == 'ppc':
            if scsi == 0:
                self.addNewPartition('prep', (8, -1, 0), (drive,-1,0), (0,0))
                if drive and drive[0:2] == 'vd':
                    part = 1
	elif os.uname ()[4] != 'sparc64':
	    self.addNewPartition('/boot', (48, -1, 0), (None,-1,0), (0,0))
	self.addNewPartition('/', (1100, -1, 1), (drive, part, 0), (0,0))
 	self.setClearParts(FSEDIT_CLEAR_LINUX, 
#	    warningText = N_("You are about to erase any preexisting Linux "
#			     "installations on your system."))
	    warningText = N_("Automatic partitioning will erase any preexisting Linux "
			     "installations on your system."))

        # 2.4 kernel requires more swap, so base amount we try to get
        # on amount of memory
        (minswap, maxswap) = iutil.swapSuggestion()
	self.addNewPartition('swap', (minswap, maxswap, 1), (None, -1, 0), (0,0))
